
public class AnimatedLists {

	private int length;
	private int [] sequence;
	private int speed;
	
	private int pos;
	
	
	public AnimatedLists(int length, int [] sequence, int speed)
	{
		this.length = length;
		
		this.sequence = new int[length];
		
		for (int i = 0; i < length; i++)
		{
			this.sequence[i] = sequence[i];
		}
		
		this.speed = speed;
		
		// set to the first position
		this.pos = 0;
	}
	
	
	/*
	 * returns the next Image index in the sequence
	 * and increments the position
	 * this is the default procedure - which goes forward, in a logical sequence
	 */
	public int getNext()
	{
		return goForward();
	}
	
	public int getNext(int direction)
	{
		if (direction == -1)
			return goBack();
		else // direction == 1
			return goForward();
	}
	
	public int goForward()
	{
		if (++this.pos == this.length)
			this.pos = 0;
		return this.sequence[this.pos];
	}
	
	public int goBack()
	{
		if (--this.pos == -1)
			this.pos = this.length - 1;
		return this.sequence[this.pos];
	}
	
	/*
	 * returns the current sequence index
	 */
	public int getPos()
	{
		return this.pos;
	}
	
	/*
	 * returns the current Image index in the sequence
	 */
	public int getImagePos()
	{
		return this.sequence[this.pos];
	}
	
}
