import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.util.*;		// for Random
import java.awt.geom.*;
import java.net.*;
import java.awt.image.*;
import javax.sound.sampled.*;

public class GameClass extends Applet implements Runnable, KeyListener {

	Thread game;
	public Network network;
	public Graphics2D g2d;
	public BufferedImage scene;
	public Machine tarkus;
	public GameObject enemy;
	public GameObject [] enemies;
	public GameObject bullet;
	public GameObject [] bullets;
	public int screenWidth;
	public int screenHeight;
	private final static int GAME_PRE = 0;
	private final static int GAME_START = 1;
	private final static int GAME_POST  = 2;
	private int game_state; 
	private Toolkit kit;
	private int bulletCount;
	private final int BULLET_MAX = 30;
	private int enemyCount;
	private final int ENEMY_MAX = 8;
	private final int TIME = 50;
	private Random random;
	private int life;
	private int currentLevel;
	private final static int NUM_LEVELS = 10;
	private int score;
	private Image background;
	private int enemyWorth; 
	private int networkWorth;
	
	private boolean rightKey;
	private boolean leftKey;
	private boolean upKey;
	private boolean downKey;
	private boolean enter;
	private boolean spacebar;
	private boolean escKey;
	
	//private AudioInputStream continuous_music;
	private Clip continuousMusic;
	private Clip shootPotato;
	private Clip frogBorn;
	
	//private int difficulty;
	
	
		
	public URL getResource(String str)
	{
		URL url = null;
		try 
		{
			url = this.getClass().getResource(str);
		}
		catch (Exception e) { System.out.println("Uh-oh...");}
		return url;
	}
	
	// this method is called when the applet is initially loaded
	public void init()
	{
		
		screenWidth = 700;
		screenHeight = 700;
		
		scene = new BufferedImage(screenWidth, screenHeight, BufferedImage.TYPE_INT_RGB);
		g2d = (Graphics2D) scene.getGraphics();//(Graphics2D) this.getGraphics();
		
		this.setSize(screenWidth, screenHeight);
		
		game_state = GAME_PRE;
			
		game = new Thread(this);
		
		clearKeys();
		
		//difficulty = 0;
		
		this.addKeyListener(this);
		
		random = new Random();
		kit = Toolkit.getDefaultToolkit();
		
		try 
		{
			AudioInputStream file = AudioSystem.getAudioInputStream(getResource("sounds/wotw_1.wav"));
			continuousMusic = AudioSystem.getClip();
			shootPotato = AudioSystem.getClip();
			frogBorn = AudioSystem.getClip();
			continuousMusic.open(file);
			frogBorn.open(AudioSystem.getAudioInputStream(getResource("sounds/duck.wav")));
			shootPotato.open(AudioSystem.getAudioInputStream(getResource("sounds/sos.wav")));
			
		}
		catch (Exception e) { System.err.println("That's just too bad");}
		
		
		bulletCount = 0;
		life = 150;
		currentLevel = 1;
		score = 0;
		enemyWorth = 25 * currentLevel;
		networkWorth = 100 * currentLevel;
		
		URL url7 = null;
		
		
		
		background = kit.getImage(getResource("images/backpotato.png"));
		initializeBullets();
		initializeNetwork(currentLevel);
		initializeEnemies(currentLevel);
		initializeMachine();
		
		try
		{
			url7 = this.getClass().getResource("images/frog.png");
			
		}
		catch (Exception e)
		{
			System.out.println("Guess that did not work, eh ?! :(");
		}
		
		
		//enemy = new GameObject(2, 2, new Image[] {kit.getImage(url8), kit.getImage(url9)}, 50, 50, this);
				
		
		//enemy.createAnimatedLists(GameObject.OBJ_ON, new int[] {0, 0, 0, 1, 1, 1}, 50);
		//enemy.createAnimatedLists(GameObject.OBJ_OFF, new int[] {0}, 50);
		//enemy.setState(GameObject.OBJ_ON);
		
		
		
		//enemy.setVelX(2);
		//enemy.setVelY(2);
		
		//enemy.setState(GameObject.OBJ_ON);
		
		
		
			
	}
	
	public void restartGame()
	{
		life = 150;
		bulletCount = 0;
		bullets = null;
		network = null;
		enemies = null;
		currentLevel = 1;
		initializeBullets();
		initializeNetwork(currentLevel);
		initializeEnemies(currentLevel);
		game_state = GAME_START;
		score = 0;
		//System.out.println("State is: " + game_state);
	}
	
	public void initializeMachine()
	{
		continuousMusic.loop(Clip.LOOP_CONTINUOUSLY);
		tarkus = new Machine(3, 2,
				new Image [] {kit.getImage(getResource("images/machine_1.png")), 
							  kit.getImage(getResource("images/machine_2.png")),
							  kit.getImage(getResource("images/machine_3.png"))}, 250, 250, this);
		
		tarkus.createAnimatedLists(GameObject.OBJ_ON, new int [] {0, 0, 0, 1, 1, 1, 2, 2, 2}, 50);
		tarkus.createAnimatedLists(GameObject.OBJ_OFF, new int[] {0}, 50);
		tarkus.setState(GameObject.OBJ_ON);
		
	}
	
	public void initializeNetwork(int level)
	{
		//public Network(int numOfClusters, int numOfStations, Image station_off_1, Image station_off_2, Image station_on, Applet applet)
		//network = new Network(((currentLevel % 2) == 0) ? 2 : 1, difficulty + 2, kit.getImage(getResource("images/station_off_1.png")), 
		network = new Network(((currentLevel % 2) == 0) ? 2 : 1, 4, kit.getImage(getResource("images/station_off_1.png")), 
				kit.getImage(getResource("images/station_off_2.png")), 
				kit.getImage(getResource("images/station_on.png")), this);
		
		for (GameObject s : network.getStations())
		{
			s.setState(GameObject.OBJ_ON);
		}
	}
	
	public void initializeBullets()
	{
		bullets = new GameObject[BULLET_MAX];
		
		// get the image for the bullet and create the GameObjects for the bullets
		// we have 30 bullets 
		for (int i = 0; i < 30; i++)
		{
			bullets[i] = new GameObject(1, 2, new Image[] {kit.getImage(getResource("images/bullet_2.png"))}, 0, 0, this);
			bullets[i].createAnimatedLists(GameObject.OBJ_ON, new int[]{0}, 50);
			bullets[i].createAnimatedLists(GameObject.OBJ_OFF, new int[]{0}, 50);
			bullets[i].setWrap(false);
						
		}
	}
	
	public void initializeEnemies(int level)
	{
		enemies = new GameObject[ENEMY_MAX];
		
		for (int i = 0; i < ENEMY_MAX; i++)
		{
			enemies[i] = new GameObject(5, 3,
					new Image[] {kit.getImage(getResource("images/surface_1.png")),
								 kit.getImage(getResource("images/surface_2.png")),
								 kit.getImage(getResource("images/surface_3.png")),
								 kit.getImage(getResource("images/enemy_1_l" + ((currentLevel - 1)/2 + 1) + ".png")),//(currentLevel*2-1) + ".png")),
								 kit.getImage(getResource("images/enemy_2_l" + ((currentLevel - 1)/2 + 1) + ".png"))},
								 (int) (screenWidth * 1.0 * random.nextDouble()),
								 (int) (screenHeight * 1.0 * random.nextDouble()), this);
				
			enemies[i].createAnimatedLists(GameObject.OBJ_ON, new int[] {3, 3, 3, 4, 4, 4}, 50);
			enemies[i].createAnimatedLists(GameObject.OBJ_OFF, new int[] {3}, 50);
			enemies[i].createAnimatedLists(666, new int[] {0, 0, 0, 1, 1, 1, 2, 2, 2}, 50);
			
			enemies[i].setVelX(2);
			enemies[i].setVelY(2);
			
			enemies[i].setTurnSpeed((5 + (int) (enemies[i].random.nextDouble() * 20.0)) * 1000 / TIME);
			//System.out.println("turnSpeed: "  + enemies[i].getTurnSpeed());
		
			//enemies[i].setState(GameObject.OBJ_ON);
			//enemies[i].setState(666);
		}	
	}
	
	public void start()
	{
		game.start();
	}
	
	public void paint(Graphics g)
	{
		
		g.drawImage(scene, 0, 0, this);
	}
	
	public void update(Graphics g)
	{
		
		switch(game_state)
		{
			case GAME_PRE:
				g2d.setColor(Color.BLACK);
				g2d.fillRect(0, 0, screenWidth, screenHeight);
				
				//System.out.println("we are in GAME_PRE");
				g2d.setColor(Color.GREEN);
				
				g2d.setFont(new Font("Monospaced", Font.BOLD, 18));
				g2d.drawString("center yourself over station and press <ENTER> to select", 50, 75);
				g2d.drawString("press <SPACE> to fire toxic potatoes at mutant frogs", 50, 100);
				g2d.drawString("move around using arrowed keys", 50, 125);
				g2d.drawString("you have limited resources to restart the network,", 50, 150);
				g2d.drawString("therefore, you must select the shortest path", 50, 175);
				
				g2d.setFont(new Font("Monospaced", Font.BOLD, 25));
				g2d.drawString("instructions:", 50, 50);
				
				//if (difficulty == 0)
				//{
				//	g2d.drawString("choose your difficulty level:", 50, 200);
				//	g2d.drawString("1 (easy) - 5 (hard)", 50, 250);
				//}
				//else
				g2d.drawString("press spacebar to start new game...", 50, 250);
				break;
		
			case GAME_START:

				//System.out.println("we are in update:");
//				Graphics2D g2d = (Graphics2D) g;
				//this.setBackground(Color.BLACK);
				//g2d.setColor(Color.BLACK);
				//g2d.fillRect(0, 0, screenWidth, screenHeight);
				g2d.drawImage(background, 0, 0, this);
				
				// draw the enemies
				for (GameObject enemy : enemies)
				{
					if (enemy.getState() == GameObject.OBJ_ON)
						g2d.drawImage(enemy.getImage(), enemy.getX(), enemy.getY(), this);
					
					
					else if (enemy.getState() == 666)
					{

						g2d.drawImage(enemy.getImage(), enemy.getX(), enemy.getY(), this);
						if (enemy.getPos() == 8)
						{
							// the routine is done, start the enemy in normal mode now
							enemy.setState(GameObject.OBJ_ON);
							frogBorn.stop();
							frogBorn.setFramePosition(0);
							frogBorn.start();
						}
					}
				}
				
				
				
				
				
				
				//if (enemy.getState() == GameObject.OBJ_ON)
				//	g2d.drawImage(enemy.getImage(), enemy.getX(), enemy.getY(), this);
				
				// draw the live bullets
				for (int i = 0; i < BULLET_MAX; i++)
				{
					if (bullets[i].getState() == GameObject.OBJ_ON)
						g2d.drawImage(bullets[i].getImage(), bullets[i].getX(), bullets[i].getY(), this);
	//				System.out.println("bullets are alive");
				}
				
			
				// check if any enemy frogs were hit by bullets :P
				// currently only have one enemy frog and one bullet, lol
				checkBulletCollisions();
				checkEnemyAttack();
				
				network.draw();
				
				// write the game stats: health/life, level, score
				g2d.setColor(Color.GRAY);
				g2d.drawRect(490, 655, 150, 20);
				g2d.setColor(Color.RED);
				g2d.drawString("life: ", 410, 670);
				g2d.drawString("level " + currentLevel, 10, 30);
				g2d.drawString("score " + score, 10, 60);
				g2d.setColor(Color.GREEN);
				g2d.fillRect(490, 655, life, 20);
				
				
								
				//g2d.drawImage(tarkus.getImage(), tarkus.getX(), tarkus.getY(), this);
				tarkus.draw();
				
				break;
			
			case GAME_POST:
				g2d.setColor(Color.BLACK);
				g2d.fillRect(0, 0, screenWidth, screenHeight);
				g2d.setColor(Color.GREEN);
				if (currentLevel < 11)
				{
					g2d.drawString("Haha, loser !!", 250, 250);
				}
				else
					// you won
					g2d.drawString("Congratulations, you've won.", 150, 280);
					
				g2d.drawString("final score: " + score, 250, 310);
				g2d.drawString("press spacebar for new game, esc to quit", 50, 350);
				break;

		}
		
				paint(g);
	}
	
	public void checkEnemyAttack()
	{
		for (GameObject enemy : enemies)
		{
			if ((enemy.getState() == GameObject.OBJ_ON)
					&& (GameObject.checkCollision(enemy, tarkus)))
			{
				//System.out.println("we've been attacked");
				life--;
			}
		}
	}
	
	public void checkBulletCollisions()
	{

		int speed;
		
		for (GameObject bullet : bullets)
		{
			for (GameObject enemy : enemies)
			{
				if (GameObject.checkCollision(enemy, bullet) 
						&& bullet.getState() == GameObject.OBJ_ON
						&& enemy.getState() == GameObject.OBJ_ON)
				{
					//System.out.println("enemy is down");
					enemy.setState(GameObject.OBJ_OFF);
					enemy.clearTurn();
					// make them more rare
					speed = enemy.getTurnSpeed();
					if (speed < 1000)
						enemy.setTurnSpeed(enemy.getTurnSpeed() + enemy.getTurnSpeed()/2);
					bullet.setState(GameObject.OBJ_OFF);
					bulletCount--;
					//break;
					
					// we have hit an enemy frog, so increase score
					score += enemyWorth;
				}
			}
			if ((bullet.getState() == GameObject.OBJ_ON)
					&& ((bullet.getX() > screenWidth)
					|| (bullet.getX() < 0)
					|| (bullet.getY() < 0)
					|| (bullet.getY() > screenHeight)))
			{
				bullet.setState(GameObject.OBJ_OFF);
				bulletCount--;
			}
		}
	}
	
	public void run()
	{
		
		boolean t = true;
		
		while(true)
		{
			try
			{
				Thread.sleep(TIME);
			}
			catch (Exception e) {}
			
			
			//enemy.updatePos();
			//enemy.updateImage();
			//enemy.setRandomValuesAndUpdateAll();
			
			if (game_state == GAME_START)
			{
				updateBullets();
				updateEnemyTurns();
				network.updateImages();
				//tarkus.updatePos();
				tarkus.updateImage();
				checkLevelComplete();
				//doKeyResponseStuff();
			
				if (life <= 0)
				{
					game_state = GAME_POST;
				}
			}
			if (t)
				doKeyResponseStuff();
			repaint();
			t = !t;
		}
	}
	
	public void checkLevelComplete()
	{
		if (network.checkIfTree())
		{
			//System.out.println("we have got ourselves a tree :)");
			score += networkWorth;
			startNextLevel();
		}
	}
	
	public void startNextLevel()
	{
		System.out.println("new level");
		currentLevel++;
		if (currentLevel == 11)
		{
			System.out.println("You won");
			game_state = GAME_POST;
			return;
		}
		
		// go to the next level
		enemyWorth = 25 * currentLevel;
		networkWorth = 100 * currentLevel;
		initializeBullets();
		initializeNetwork(currentLevel);
		initializeEnemies(currentLevel);
		game_state = GAME_START;
		
	}
	
	public void updateEnemyTurns()
	{
		for (GameObject enemy : enemies)
		{
			if (enemy.getState() == GameObject.OBJ_OFF)
			{
				//System.out.println("we have some OBJ_OFFs");
				//System.out.println("...");
				enemy.incTurn();
				if (enemy.checkTime() == enemy.getTurnSpeed())
				{
					//enemy.setState(GameObject.OBJ_ON);
					enemy.setState(666);
					enemy.updateImage();
					enemy.clearTurn();
				}
			}
			//enemy.updatePos();
			//enemy.updateImage();
			else if (enemy.getState() == GameObject.OBJ_ON)
				enemy.setRandomValuesAndUpdateAll();
			else
				enemy.updateImage();
				
			
		}
	}
	
	public void updateBullets()
	{
		for (int i = 0; i < BULLET_MAX; i++)
		{
			if (bullets[i].getState() == GameObject.OBJ_ON)
				bullets[i].updatePos();
		}
	}
	
	public int getFirstFreeBullet()
	{
		for (int i = 0; i < BULLET_MAX; i++)
		{
			if (bullets[i].getState() == GameObject.OBJ_OFF)
				return i;
		}
		return -1;
	}
	
	public void keyPressed(KeyEvent k)
	{
		switch (k.getKeyCode())
		{
			case KeyEvent.VK_LEFT:
				leftKey = true;
				break;
			case KeyEvent.VK_RIGHT:
				rightKey = true;
				break;
			case KeyEvent.VK_UP:
				upKey = true;
				break;
			case KeyEvent.VK_DOWN:
				downKey = true;
				break;
			case KeyEvent.VK_SPACE:
				spacebar = true;
				break;
			case KeyEvent.VK_ENTER:
				enter = true;
				break;
			case KeyEvent.VK_ESCAPE:
				escKey = true;
				break;
		/*	case KeyEvent.VK_1:
				if ((game_state == GAME_PRE) && (difficulty == 0))
				{
					difficulty = 1;
					repaint();
				}	
				break;
			case KeyEvent.VK_2:
				if ((game_state == GAME_PRE) && (difficulty == 0))
				{
					difficulty = 2;
					repaint();
				}
				break;
			case KeyEvent.VK_3:
				if ((game_state == GAME_PRE) && (difficulty == 0))
				{
					difficulty = 3;
					repaint();
				}
				break;
			case KeyEvent.VK_4:
				if ((game_state == GAME_PRE) && (difficulty == 0))
				{
					difficulty = 4;
					repaint();
				}
				break;
			case KeyEvent.VK_5:
				if ((game_state == GAME_PRE) && (difficulty == 0))
				{
					difficulty = 5;
					repaint();
				}
			*/
			default:
					break;
		}

	//	doKeyResponseStuff();
	}
	
	public void keyReleased(KeyEvent k)	
	{
		switch (k.getKeyCode())
		{
			case KeyEvent.VK_LEFT:
				leftKey = false;
				break;
			case KeyEvent.VK_RIGHT:
				rightKey = false;
				break;
			case KeyEvent.VK_UP:
				upKey = false;
				break;
			case KeyEvent.VK_DOWN:
				downKey = false;
				break;
			case KeyEvent.VK_SPACE:
				spacebar = false;
				break;
			case KeyEvent.VK_ENTER:
				enter = false;
				break;
			case KeyEvent.VK_ESCAPE:
				escKey = false;
				break;
			default:
					break;
		}

		//doKeyResponseStuff();
	}
	
	
	
	public void doKeyResponseStuff()
	{
		int bulletIndex;
		
		if (leftKey)
		{
			tarkus.rotateLeft();
			tarkus.setVel(20);
		}
		if (rightKey)
		{
			tarkus.rotateRight();
			tarkus.setVel(20);
		}
		
		if (upKey)
		{
				tarkus.updatePos();
		}
		
		if (downKey)
		{
		
				tarkus.invert();
				tarkus.setVel(tarkus.getMag());
				tarkus.updatePos();
				tarkus.invert();
				tarkus.setVel(tarkus.getMag());
		}
		if (spacebar)
		{
			if ((game_state == GAME_PRE))// && (difficulty != 0))
			{
				game_state = GAME_START;
			//	initializeNetwork(currentLevel);
			}
			
			else if ((game_state == GAME_START)
					&& (bulletCount < BULLET_MAX))
			{
				bulletIndex = getFirstFreeBullet();
				
				bullets[bulletIndex].setVelX((int)((double)tarkus.getVelX()/(double)tarkus.getMag()*20.0));
				bullets[bulletIndex].setVelY((int)(((double)tarkus.getVelY())/(double)tarkus.getMag()*20.0));
				bullets[bulletIndex].setX(tarkus.getX() + tarkus.getWidth()/2);
				bullets[bulletIndex].setY(tarkus.getY() + tarkus.getHeight()/2);
				bullets[bulletIndex].setState(GameObject.OBJ_ON);
				
				bulletCount++;
				
				shootPotato.stop();
				// need to rewind the sound clip
				shootPotato.setFramePosition(0);
				shootPotato.start();
				
		
			}
			else if (game_state == GAME_POST)
			{
				restartGame();
			}
			
			
		//	System.out.println("shot");
			
		}
		if (enter)
		{
			network.checkCollisions(tarkus);
		}
		
		if (escKey)
		{
			if (game_state == GAME_POST)
			{
				System.out.println("End game");
				game = null;
				this.removeKeyListener(this);
				clearKeys();
			}
		}
		repaint();
	}
	
	
	public void clearKeys()
	{
		rightKey = false;
		leftKey = false;
		upKey = false;
		downKey = false;
		enter = false;
		spacebar = false;
	}
	
	
	public void keyTyped(KeyEvent k) {}
	
	public int getScreenWidth()
	{
		return this.screenWidth;
	}
	
	public int getScreenHeight()
	{
		return this.screenHeight;
	}

	public void destroy()
	{
		continuousMusic.stop();
	}
	
	
}
