import java.applet.*;
import java.awt.*;
import java.awt.geom.*;


public class Machine extends GameObject
{

	private int motion;
	private int mag;


	public Machine(int imageSetSize, int numOfStates, Image [] imageFiles, int x, int y, Applet applet)
	{

		super(imageSetSize, numOfStates, imageFiles, x, y, applet);
		motion = 4;
		setVel(20);

	}

	public void draw()
	{
		Graphics2D g2d = (Graphics2D) ((GameClass) applet).g2d;
		
		transform = new AffineTransform();
		
		transform.setToIdentity();
		
		transform.translate(getX(), getY());
		//System.out.println("rotation: " + (- (getMotion() * 22.5 - 90)));
		//System.out.println("getMotion(): " + getMotion());
		transform.rotate(- Math.toRadians((getMotion() * 22.5 - 90)), getWidth()/2, getHeight()/2);
		
		//transform.rotate(Math.toRadians(-90), getWidth()/2, getHeight()/2);
		
		g2d.drawImage(getImage(), transform, applet);
	}
	
	
	public void rotateLeft()
	{
		
		this.motion++;
		//if (motion == 8)
		if (motion == 16)
			motion = 0;
		
		//setVel(5);

	}

	public void rotateRight()
	{
		this.motion--;
		if (motion == -1)
			//motion = 7;
			motion = 15;
	
		//setVel(5);


	}

	public void invert()
	{
		
		motion = (motion + 8) % 16;

	}


	public int getMotion()
	{
		return this.motion;
	}


	public int getMag()
	{
		return this.mag;
	}


	public void setVel(int mag)
	{

		this.mag = mag;

		switch (this.motion)
		{
			case 0:
				// 0 / 360 degrees
				super.setVelX(mag);
				super.setVelY(0);
				break;
			case 1: 
				// 22.5 degrees
				super.setVelX((int)(Math.cos(Math.toRadians(22.5)) * mag));
				super.setVelY(-(int)(Math.sin(Math.toRadians(22.5)) * mag));
				break;
			case 2:
				// 45 degrees
				super.setVelX((int)(Math.cos(Math.toRadians(45))*mag));
				super.setVelY(-(int)(Math.sin(Math.toRadians(45))*mag));
				break;
			case 3:
				// 67.5 degrees
				super.setVelX((int)(Math.cos(Math.toRadians(67.5)) * mag));
				super.setVelY(-(int)(Math.sin(Math.toRadians(67.5)) * mag));
				break;
			case 4:
				// 90 degrees
				super.setVelX(0);
				super.setVelY(-mag);
				break;
			case 5:
				// 112.5 degrees
				super.setVelX((int)(Math.cos(Math.toRadians(112.5)) * mag));
				super.setVelY(-(int)(Math.sin(Math.toRadians(112.5)) * mag));
				break;
			case 6:
				// 135 degrees
				super.setVelX((int)(Math.cos(Math.toRadians(135))*mag));
				super.setVelY(-(int)(Math.sin(Math.toRadians(135))*mag));
				break;
			case 7:
				// 157.5 degrees
				super.setVelX((int)(Math.cos(Math.toRadians(157.5)) * mag));
				super.setVelY(-(int)(Math.sin(Math.toRadians(157.5)) * mag));
				break;
			case 8:
				// 180 degrees
				super.setVelX(-mag);
				super.setVelY(0);
				break;
			case 9:
				// 202.5 degrees
				super.setVelX((int)(Math.cos(Math.toRadians(202.5)) * mag));
				super.setVelY(-(int)(Math.sin(Math.toRadians(202.5)) * mag));
				break;
			case 10:
				// 225 degrees
				super.setVelX((int)(Math.cos(Math.toRadians(225))*mag));
				super.setVelY(-(int)(Math.sin(Math.toRadians(225))*mag));
				break;
			case 11:
				// 247.5 degrees
				super.setVelX((int)(Math.cos(Math.toRadians(247.5)) * mag));
				super.setVelY(-(int)(Math.sin(Math.toRadians(247.5)) * mag));
				break;
			case 12:
				// 270 degrees
				super.setVelX(0);
				super.setVelY(mag);
				break;
			case 13:
				// 292.5 degrees
				super.setVelX((int)(Math.cos(Math.toRadians(292.5)) * mag));
				super.setVelY(-(int)(Math.sin(Math.toRadians(292.5)) * mag));
				break;
			case 14:
				// 315 degrees
				super.setVelX((int)(Math.cos(Math.toRadians(315))*mag));
				super.setVelY(-(int)(Math.sin(Math.toRadians(315))*mag));
				break;
			case 15:
				// 337.5
				super.setVelX((int)(Math.cos(Math.toRadians(337.5)) * mag));
				super.setVelY(-(int)(Math.sin(Math.toRadians(337.5)) * mag));
				break;
			default:
				break;
				


		}

	}



}
